/*
 * Copyright 2021 dorkbox, llc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package dorkbox.dns.dns.zone

import dorkbox.dns.dns.Name
import dorkbox.dns.dns.records.DnsRecord

/**
 * @author taichi
 */
class Query(
    protected var origin: Name,
    protected var current: Name,
    protected var dnsClass: Int,
    protected var target: Zone,
    protected var database: ZoneDatabase
) {
    protected operator fun contains(rrs: List<DnsRecord>): Boolean {
        for (rr in rrs) {
            if (origin.equals(rr.name)) {
                return true
            }
        }
        return false
    }
}
